; -----------------------------------------------------------------------------
; RetroForth for "Generic" Systems
; -----------------------------------------------------------------------------
include "macros.fasm"

format elf


extrn putchar
extrn getchar
extrn exit
extrn open
extrn close
extrn read
extrn write
extrn chmod
extrn dlopen
extrn dlsym

public main

main:
	call init_retroforth
	upop ebx
	jmp ebx
;---------------------------------------------------------------------
fname rb 256
erase_it:
        upsh fname
        embed '256 0 fill'
        next

code 'use', __use
        call erase_it
        upsh 32
        call parse
        upsh fname
        swap
        embed 'move'
        next

__nblk: embed '#blks @ 512 *'
        ret

__file dd 0
__open:
        dup
        push 66
        push fname
        call open
        add esp, 8
        mov [__file], eax
        push 438                ; 0666 in octal
        push fname
        call chmod
        drop
        add esp, 8
next
__close:
        push dword [__file]
        dup
        call close
        add esp, 4
        drop
next
code 'r', __read
        dup
        embed 'new'
        call __open
        call __nblk
        upop ebx
        push ebx
        push blk
        push dword [__file]
        call read
        add esp, 12
        call __close
        drop
next
code 'w', __write
        dup
        call __open
        call __nblk
        upop ebx
        push ebx
        push blk
        push dword [__file]
        call write
        add esp, 12
        call __close
        drop
next

code 'load', __load
	call __use
	jmp __read
code 'bye', bye
	push 0
	call exit
code 'emit', emit
	pusha
	push eax
	call putchar
	pop eax
	popa
	drop
ret
code 'key', key
	dup
	call getchar
ret
code 'type',type	        ;
	push ebx	        ;
	push ecx	        ;
	upop ecx	        ;
	upop ebx	        ;
	or ecx,ecx	        ; Is the count zero?
	jz .done	        ; If so, we can exit
.a:	push ecx	        ; store the count
	dup		        ; Duplicate it
	xor eax,eax	        ; Filter out junk bits
	mov al,[ebx]	        ; Obtain the byte to show
	inc ebx 	        ; increment to the next byte
	call emit	        ; Show the character
	pop ecx 	        ; Restore the count
	loop .a 	        ; Loop, decrementing the count
.done:	pop ecx 	        ;
	pop ebx 	        ;
next
;---------------------------------------------------------------------
lib_addr dd 0
; void *dlopen(const char *file, int mode); 
code 'from', _from
        upsh 32
        call parse
        embed 'zt'
        upop edx
        pusha
	push 0
	push edx
	call dlopen
	add esp, 8
        mov dword [lib_addr], eax
        popa
next
; void *dlsym(void *restrict handle, const char *restrict name); 
code 'import', _import
        pusha
        upsh 32
        call parse
        embed '2dup entry zt'
        upop edx
	push edx
	push [lib_addr]
	call dlsym
	add esp, 8
        call literal
        popa
        call literal
        upsh _pascal_invoke
        call compile
        jmp ssemi
code 'cimport', _cimport
        pusha
        upsh 32
        call parse
        embed '2dup entry zt'
        upop edx
	push edx
	push [lib_addr]
	call dlsym
	add esp, 8
        call literal
        popa
        call literal
        upsh _c_invoke
        call compile
        jmp ssemi

_pascal_invoke:
        swap
        upop [faddr]            ; Get the function address
        upop ecx
        cmp ecx, 0
        jz .run
.chain: push eax
        drop
        loop .chain
.run:   upsh [faddr]            ; Restore the function address
        call dword eax
next

_c_invoke:
        swap
        upop [faddr]            ; Get the function address
        xor ebx,ebx
        upop ecx
        cmp ecx, 0
        jz .run
.chain: push dword eax
        drop
        add ebx, 4
        loop .chain
.run:   mov dword [tempX], ebx
        upsh [faddr]            ; Restore the function address
        call dword eax
        mov ebx, dword [tempX]
        add esp, ebx
next
faddr dd 0
tempX dd 0
;---------------------------------------------------------------------
include 'core.asm'		; RetroForth itself
